
;
; Gestion saisie d'un mot au clavier
;
SaisieMot:
        CALL    VideBuffClav
        LD      HL,MotSaisi
        LD      DE,MotSaisi+1
        LD      (HL),0
        LD      BC,TailleMot-1
        LDIR
        LD      HL,MotSaisi
        LD      B,TailleMot             ; Nbre max. de caractres   saisir
SaisieMotBcl:
        PUSH    BC
        PUSH    HL
SaisieMotCar:
        CALL    GetKeyClav
        JR      NC,SaisieMotCar
        POP     HL
        POP     BC
        CP      13
        JR      Z,SaisieFin
        CP      252                     ; ESC
        JP      Z,CursClavOff
        CP      127                     ; DEL
        JR      Z,SaisieDelCar
        LD      D,A
        LD      A,B
        AND     A
        JR      Z,SaisieMotBcl
        DEC     B
        LD      A,D
        CP      32
        JR      C,SaisieMotBcl
        CP      #5B
        JR      C,SaisieSetCar
        AND     #5F
SaisieSetCar:
        CALL    #BB5A
        LD      (HL),A
        INC     HL
        JR      SaisieMotBcl
SaisieDelCar:
        LD      A,B
        CP      TailleMot               ; Dj tout effac ?
        JR      Z,SaisieMotBcl
        LD      A,32
        CALL    #BB5A
        LD      A,8
        CALL    #BB5A
        LD      A,8                     ; Backspace
        CALL    #BB5A
        LD      A,32                    ; Blanc
        CALL    #BB5A
        LD      A,8                     ; Backspace
        CALL    #BB5A
        INC     B
        DEC     HL
        XOR     A
        LD      (HL),A
        JR      SaisieMotBcl

SaisieFin:
        LD      A,B
        CP      TailleMot
        JR      Z,SaisieMotBcl
        CALL    CursClavOff
        RET
;
; Scanning clavier et affichage curseur
; Sortie Flag C=1 si touche appuye et A contient le code de la touche
;
GetKeyClav:
        LD      A,127                   ; Affiche curseur
        LD      (CursClavOff+1),A
        CALL    #BB5A
        LD      A,8                     ; BackSpace
        CALL    #BB5A
        CALL    #BB09                   ; Lit clavier
        PUSH    AF
GetKeyClav2:
        LD      A,0                     ; Tempo clignottement curseur
        INC     A
        LD      (GetKeyClav2+1),A
        CP      CursorBlinkSpeed
        JR      C,GetKeyClav3
        XOR     A
        LD      (GetKeyClav2+1),A
        LD      A,(GetKeyClav+1)
        XOR     95                      ; 127 XOR 95 = 32 (pour clignottement)
        LD      (GetKeyClav+1),A
GetKeyClav3:
        CALL    #BD19
        POP     AF
        RET

;
; Efface le curseur de saisie clavier
;
CursClavOff:
        LD      A,1
        AND     A
        RET     Z
        LD      (CursClavOff+1),A
        LD      A,32
        CALL    #BB5A
        LD      A,8
        CALL    #BB5A
        RET
