;
; Entre - HL = adresse buffer  dcompacter
;
DepkWin:
        LD      A,6
        CALL    SetBank                 ; Banque 6 = buffer dcompactage
        LD      DE,XD
        LDI                             ; Stockage XD
        LDI                             ; Stockage YD
        LDI                             ; Stockage XA
        LDI                             ; Stockage YA
        LD      DE,BuffSpt
        PUSH    DE
        CALL    DepkLzw                 ; Dcompactage
        CALL    CalcStart               ; Calcule adresse dbut et taille
        POP     DE
SptScr:
        LD      HL,0
NbCol:
        LD      A,0
Draw1:
        PUSH    AF
        PUSH    HL
NbLig:
        LD      A,0
Draw2:
        EX      DE,HL
        LDI
        EX      DE,HL
        LD      BC,#7FF
        ADD     HL,BC
        JR      NC,Draw3
        LD      BC,#C050
        ADD     HL,BC
Draw3:
        DEC     A
        JR      NZ,Draw2
        POP     HL
        INC     HL
        POP     AF
        DEC     A
        JR      NZ,Draw1
        RET

;
; Calcule adresse dbut dans HL
;
CalcStart:
        LD H,#C0
        LD A,(XD)
        LD L,A
        LD A,(YD)
        LD B,A
        AND A
        JR Z,CalcDebBcl
CalcS1:
        LD      DE,#800
        ADD     HL,DE
        JR      NC,CalcS2
        LD      DE,#C050
        ADD     HL,DE
CalcS2:
        DJNZ CalcS1

;
; Calcule nbre de Y
;
CalcDebBcl:
        LD      A,(YD)
        LD      B,A
        LD      A,(YA)
        SUB     B
        INC     A
        LD      B,A              ; B = nbre de y
;
; Calcule nbre de X
;
        LD      A,(XD)

        LD      C,A
        LD      A,(XA)
        SUB     C
        INC     A
        LD      (NbCol+1),A      ; nbre de x
        NEG
        LD      (NbSub+1),A
        LD      A,B
        LD      (NbLig+1),A
        LD      (SptScr+1),HL
        RET

;
; Affiche une fentre avec un message
; Entre
; - HL = adresse donnes fentre
; donnes fentre :
; - XD,YD,XA,YA,messages (13 pour nouvelle ligne, 0 pour fin )
;
AfficheWinMsg:
        LD      A,5
        CALL    SetBank                 ; Banque 5 = dialogues
        LD      DE,XD
        LDI                             ; Stockage XD
        LDI                             ; Stockage YD
        LDI                             ; Stockage XA
        LDI                             ; Stockage YA
        PUSH    HL
        CALL    CalcStart               ; Calcule adresse dbut et taille
        POP     HL

        PUSH    HL                      ; Sauvegarde adresse message fentre
        LD      HL,(SptScr+1)
NbSub:
        LD      A,0
        INC     A
        LD      (NBSUB2+1),A
        LD      (NBSUB3+1),A
        LD      A,(NbCol+1)
        LD      C,A
        DEC     A
        DEC     A
        LD      (NBCLS+1),A
        LD      D,H
        LD      E,L
        INC     DE
        DEC     C
        XOR     A
        LD      B,A
        DEC     A
        LD      (HL),A
        LDIR
NBSUB2:
        LD      BC,#7FF
        ADD     HL,BC
        JR      NC,DESFEN2
        LD      BC,#C050
        ADD     HL,BC
DESFEN2:
        LD      A,(NbLig+1)
        DEC     A
        DEC     A
BCLDES:
        LD      (HL),#88
        INC     HL
        LD      D,H
        LD      E,L
NBCLS:
        LD      BC,0
        LD      (HL),B
        INC     DE
        LDIR
        INC     C
        LD      (HL),C
NBSUB3:
        LD      BC,#7FF
        ADD     HL,BC
        JR      NC,DESFEN3
        LD      BC,#C050
        ADD     HL,BC
DESFEN3:
        DEC     A
        JR      NZ,BCLDES
        LD      A,(NbCol+1)
        LD      C,A
        XOR     A
        LD      B,A
        LD      D,H
        LD      E,L
        DEC     C
        LD      A,#0F
        LD      (HL),A
        INC     DE
        LDIR

        LD      HL,(SptScr+1)
        LD      BC,#51
        ADD     HL,BC
        LD      A,H
        AND     #C7
        LD      H,A
        POP     DE                      ; Rcupre adresse messages fentre
        LD      (PtrEcWin+1),HL
PrtMWin:
        LD      A,(DE)
        INC     DE
        AND     A
        RET     Z
        CP      13
        JR      NZ,PrtMWin2
PtrEcWin:
        LD      HL,0
        LD      BC,#50
        ADD     HL,BC
        LD      (PtrEcWin+1),HL
        JR      PrtMWin
PrtMWin2:
        SUB     32
        PUSH    DE
        PUSH    HL
        EX      DE,HL
        LD      L,A
        LD      H,0
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        LD      BC,NewChar
        ADD     HL,BC
        LD      BC,#8FF
PrtMWin3:
        LDI
        DEC     DE
        LD      A,D
        ADD     A,8
        LD      D,A
        DJNZ    PrtMWin3
        POP     HL
        INC     HL
        POP     DE
        JR      PrtMWin
