JouePoker:
        LD      HL,MasqueCartes
        LD      DE,MasqueCartes+1
        LD      (HL),0
        LDI
        LDI
        LDI
        LDI
        LD      L,0
PrCarteR0:
        LD      H,0
PrCarteR1:
        PUSH    HL
        PUSH    HL
        CALL    CopieEcran
        POP     HL
        CALL    DrawCarteRetournee
        CALL    RestoreAdrEcr
        POP     HL
        INC     H
        LD      A,H
        CP      5
        JR      C,PrCarteR1
        INC     L
        LD      A,L
        CP      2
        JR      C,PrCarteR0

        CALL    MelangeJeu
        CALL    PrCarteJoueur

        LD      HL,DialFinJeuVue35
        CALL    AfficheWinMsg

BclCurseur:
        CALL    CurseurOn               ; Afficher le curseur
BclFleche:
        CALL    MovCursor               ; Dplacer le curseur
        LD      A,(FIPR)
        AND     A                       ; Click ?
        JR      Z,BclFleche
        LD      A,(X)
        AND     #39
        CP      #39
        JR      Z,ZoneFin
        LD      A,(Y)
        CP      32
        JR      C,ZoneFin
        LD      A,(Y)
        CP      104
        JR      NC,ZoneFin
        LD      HL,(X)
        RL      L
        RL      H
        RL      L
        RL      H
        LD      C,H
        LD      B,0
        PUSH    BC
        CALL    CurseurOFF
        POP     BC
        LD      HL,MasqueCartes
        ADD     HL,BC
        LD      A,1
        XOR     (HL)
        LD      (HL),A
        AND     A
        JR      Z,CarteNonMasquee
        LD      L,1
        LD      H,C
        PUSH    HL
        CALL    CopieEcran
        POP     HL
        CALL    DrawCarteRetournee
        CALL    RestoreAdrEcr
        JR      BClCurseur
CarteNonMasquee:
        LD      IX,Jeu32Cartes+5
        ADD     IX, BC
        LD      L,1
        LD      H,C
        CALL    PrCartePl
        JR      BClCurseur

ValideJeu:
        LD      IX,Jeu32Cartes+5
        LD      IY,Jeu32Cartes+10
        LD      DE,MasqueCartes
        LD      H,0
        LD      L,1
ValideJeu1:
        LD      A,(DE)
        AND     A
        JR      Z,ValideJeu2
        LD      C,(IY+0)
        LD      A,(IX+0)
        LD      (IX+0),C
        LD      (IY+0),A
        PUSH    DE
        CALL    PrCartePl
        POP     DE
        INC     IY
ValideJeu2:
        INC     IX
        INC     DE
        INC     H
        LD      A,H
        CP      5
        JR      C,ValideJeu1
        RET

ZoneFin:
        LD      A,(Y)
        CP      24
        JP      NC,BclFleche
        CALL    CurseurOff              ; Effacer le curseur

        LD      HL,#C6E0
        LD      B,24
EffLigne:
        PUSH    BC
        PUSH    HL
        LD      D,H
        LD      E,L
        LD      (HL),0
        LD      BC,79
        INC     DE
        LDIR
        POP     HL
        CALL    #BC26
        POP     BC
        DJNZ    EffLigne

        CALL    ValideJeu
        CALL    PrCarteJoueur

;
; Afficher un message du genre "je change x cartes"
; faire une pause, puis afficher "voici mon jeu"
;
        LD      HL,Jeu32Cartes
        CALL    TriCartes               ; Trier jeu CPC
        LD      HL,Jeu32Cartes+5
        CALL    TriCartes               ; Trier jeu Joueur

        LD      IX,Jeu32Cartes+5
        CALL    CalcScore
        LD      A,(TypeScore)
        RRCA
        RRCA
        RRCA
        RRCA
        LD      (ScoreJoueur),A

        LD      IX,Jeu32Cartes
        CALL    CalcScore
        LD      A,(TypeScore)
        RRCA
        RRCA
        RRCA
        RRCA
        LD      (ScoreCPC),A

        CALL    PrCarteCPC
        RET

;
; IX = pointeur vers les 5 cartes du joueur
; Les cartes doivent tre tris par ordre croissant !!!
;
CalcScore:
        XOR     A
        LD      (TypeScore),A           ; Mettre le score  zro par dfaut
        LD      L,(IX+0)                ; Premire carte
        LD      B,(IX+1)                ; Seconde carte
        LD      C,(IX+2)                ; Troisime carte
        LD      D,(IX+3)                ; Quatrime carte
        LD      E,(IX+4)                ; Cinquime carte
        RES     0,L
        RES     0,B
        RES     0,C
        RES     0,D
        RES     0,E
        RES     1,L
        RES     1,B
        RES     1,C
        RES     1,D                     ; Ne garder que la valeur, masquer la
        RES     1,E                     ; couleur (Bits 0-1 = couleur)

        LD      A,L
        CP      B
        JR      Z,CalcPaire
        LD      A,B
        CP      C
        JR      Z,CalcPaire
        LD      A,C
        CP      D
        JR      Z,CalcPaire
        LD      A,D
        CP      E
        JP      NZ,CalSuite
CalcPaire:
        OR      #1
        LD      (TypeScore),A
        LD      A,L
        CP      B
        JR      NZ,Calc2Paire2
        LD      A,C
        CP      D
        JR      NZ,Calc2Paire1
        OR      #2
        LD      (TypeScore),A
        JR      CalcBrelan
Calc2Paire1:
        LD      A,D
        CP      E
        JR      NZ,CalcBrelan
        OR      #2
        LD      (TypeScore),A
        JR      CalcBrelan
Calc2Paire2:
        LD      A,B
        CP      C
        JR      NZ,CalcBrelan
        LD      A,D
        CP      E
        JR      NZ,CalcBrelan
        OR      #2
        LD      (TypeScore),A
        JR      CalcBrelan
CalcBrelan:
        LD      A,L
        CP      B
        JR      NZ,CalcBrelan2
        CP      C
        JR      NZ,CalcBrelan2
        OR      #3
        LD      A,3
        JR      CalcFullHouse
CalcBrelan2:
        LD      A,B
        CP      C
        JR      NZ,CalcBrelan3
        CP      D
        JR      NZ,CalcBrelan3
        OR      #3
        LD      (TypeScore),A
        JR      CalcFullHouse
CalcBrelan3:
        LD      A,C
        CP      D
        JR      NZ,CalcFullHouse
        CP      E
        JR      NZ,CalcFullHouse
        OR      #3
        LD      (TypeScore),A
CalcFullHouse:
        LD      A,L
        CP      B
        JR      NZ,CalcCarre
        CP      C
        JR      NZ,CalcFullHouse2
        LD      A,D
        CP      E
        JR      NZ,CalcFullHouse2
        OR      #6
        LD      (TypeScore),A
        JR      CalcCarre
CalcFullHouse2:
        LD      A,C
        CP      D
        JR      NZ,CalcCarre
        CP      E
        JR      NZ,CalcCarre
        OR      #6
        LD      (TypeScore),A
CalcCarre:
        LD      A,L
        CP      B
        JR      NZ,CalcCarre2
        CP      C
        JR      NZ,CalSuite
        CP      D
        JR      NZ,CalSuite
        OR      #7
        LD      (TypeScore),A
        JR      CalSuite
CalcCarre2:
        LD      A,B
        CP      C
        JR      NZ,CalSuite
        CP      D
        JR      NZ,CalSuite
        CP      E
        JR      NZ,CalSuite
        OR      #7
        LD      (TypeScore),A
CalSuite:
        LD      A,B
        SUB     #10
        CP      L
        JR      NZ,CalcFlush
        LD      A,C
        SUB     #20
        CP      L
        JR      NZ,CalcFlush
        LD      A,D
        SUB     #30
        CP      L
        JR      NZ,CalcFlush
        LD      A,E
        SUB     #40
        CP      L
        JR      NZ,CalcFlush
        OR      #4
        LD      (TypeScore),A
        CALL    CalcCouleurs
        LD      A,H
        CP      B
        RET     NZ
        CP      C
        RET     NZ
        CP      D
        RET     NZ
        CP      E
        RET     NZ
        LD      A,(IX+0)
        AND     #F0
        OR      #8
        LD      (TypeScore),A
        LD      A,(IX+4)
        AND     #F0
        CP      #70
        RET     NZ
        OR      #9
        LD      (TypeScore),A
        RET
CalcFlush:
        CALL    CalcCouleurs
        LD      A,H
        CP      B
        RET     NZ
        CP      C
        RET     NZ
        CP      D
        RET     NZ
        CP      E
        RET     NZ
        LD      A,(IX+0)
        AND     #F0
        OR      #5
        LD      (TypeScore),A
        RET
CalcCouleurs:
        LD      A,(IX+0)
        AND     3
        LD      H,A
        LD      A,(IX+1)
        AND     3
        LD      B,A
        LD      A,(IX+2)
        AND     3
        LD      C,A
        LD      A,(IX+3)
        AND     3
        LD      D,A
        LD      A,(IX+4)
        AND     A
        LD      E,A
        RET
TypeScore:
        DB      0

;
; Tri les 5 cartes d'un joueur
; Entre
; HL = pointeur vers les 5 cartes du joueur
;
TriCartes:
        LD      B,4
TriCarte1:
        PUSH    BC
        PUSH    HL
        LD      D,H
        LD      E,L
        INC     DE
TriCarte2:
        PUSH    BC
        LD      A,(HL)
        LD      C,A
        LD      A,(DE)
        LD      B,A
        CP      C
        JR      NC,TriCarte3
        LD      (HL),B
        LD      A,C
        LD      (DE),A
TriCarte3:
        INC     HL
        INC     DE
        POP     BC
        DJNZ    TriCarte2
        POP     HL
        POP     BC
        DJNZ    TriCarte1
        RET

;
; Affiche les 5 cartes du CPC
;
PrCarteCPC:
        LD      IX,Jeu32Cartes
        LD      H,0
        LD      L,0
PrCarteCPC1:
        CALL    PrCartePl
        INC     IX
        INC     H
        LD      A,H
        CP      5
        JR      NZ,PrCarteCPC1
        RET

;
; Affiche les 5 cartes du Joueur
;
PrCarteJoueur:
        LD      IX,Jeu32Cartes+5
        LD      H,0
        LD      L,1
PrCarteJoueur1:
        CALL    PrCartePl
        INC     IX
        INC     H
        LD      A,H
        CP      5
        JR      NZ,PrCarteJoueur1
        RET

;
; Affiche une carte
; Entre
; IX = pointeur vers valeur carte
; H = numro de carte
; L = numro de joueur
;
PrCartePl:
        LD      A,(IX+0)
        RRCA
        RRCA
        RRCA
        RRCA
        AND     #7
        LD      B,A
        LD      A,(IX+0)
        AND     #3
        LD      C,A
        PUSH    HL
        PUSH    BC
        PUSH    HL
        CALL    CopieEcran
        POP     HL
        POP     BC
        CALL    DrawCarte
        CALL    RestoreAdrEcr
        POP     HL
        RET

MelangeJeu:
        LD      D,#C0
        LD      B,0
Melange1:
        HALT
        LD      A,R
        XOR     (HL)
        RRCA
        RRCA
        RRCA
        RRCA
        LD      H,A
        LD      A,R
        XOR     (HL)
        AND     #1F
        LD      C,A
        LD      HL,Jeu32Cartes
        ADD     HL,BC
        LD      A,(HL)
        LD      E,A
        PUSH    HL
        LD      A,R
        XOR     (HL)
        RRCA
        RRCA
        RRCA
        RRCA
        LD      H,A
        LD      A,R
        XOR     (HL)
        AND     #1F
        LD      C,A
        LD      HL,Jeu32Cartes
        ADD     HL,BC
        LD      A,(HL)
        LD      (HL),E
        POP     HL
        LD      (HL),A
        DEC     D
        JR      NZ,Melange1
        RET

;
; Affiche une carte
; Entre
; L = joueur (0=CPC, 1=Joueur)
; H = numro de carte (de 0  4)
; C = couleur carte (de 0  3)
; B = valeur carte (de 0  7)
;
DrawCarte:
        LD      A,H
        ADD     A,A
        ADD     A,A
        ADD     A,A
        INC     A
        INC     A
        LD      (CarteL2+1),A
        LD      (CarteL3+1),A
        LD      (CarteL4+1),A
        LD      (CarteL5+1),A
        LD      (CarteL6+1),A
        LD      (CarteL7+1),A
        LD      (CarteL8+1),A
        LD      A,L
        ADD     A,A
        ADD     A,A
        LD      L,A
        ADD     A,A
        ADD     A,L
        INC     A
        INC     A
        LD      (CarteL2+2),A
        INC     A
        LD      (CarteL3+2),A
        INC     A
        LD      (CarteL4+2),A
        INC     A
        LD      (CarteL5+2),A
        INC     A
        LD      (CarteL6+2),A
        INC     A
        LD      (CarteL7+2),A
        INC     A
        LD      (CarteL8+2),A
        LD      A,C
        ADD     A,226
        LD      (CarteL3Co),A
        LD      A,C
        AND     2
        RRA
        LD      H,A
        LD      A,C
        AND     1
        XOR     H
        ADD     A,A
        LD      (CarteL3Pe),A
        LD      A,B
        ADD     A,A
        LD      C,A
        LD      B,0
        LD      HL,ValCarte
        ADD     HL,BC
        LD      DE,CarteL3Ve
        LDI
        LDI
        LD      HL,CarteTxt
DrawCarte1
        LD      A,(HL)
        CP      #FF
        RET     Z
        CALL    #BB5A
        INC     HL
        JR      DrawCarte1

;
; Affiche une carte retourne
; Entre
; L = joueur (0=CPC, 1=Joueur)
; H = numro de carte (de 0  4)
;
DrawCarteRetournee:
        LD      A,H
        ADD     A,A
        ADD     A,A
        ADD     A,A
        INC     A
        LD      (CarteRL1+1),A
        LD      (CarteRL2+1),A
        LD      (CarteRL9+1),A
        LD      A,L
        ADD     A,A
        ADD     A,A
        LD      L,A
        ADD     A,A
        ADD     A,L
        INC     A
        LD      (CarteRL1+2),A
        INC     A
        LD      (CarteRL2+2),A
        LD      HL,CarteRetournee
        PUSH    AF
        CALL    DrawCarte1
        POP     AF
        LD      B,7
DrawCR1:
        PUSH    AF
        LD      HL,CarteRL2
        CALL    DrawCarte1
        POP     AF
        INC     A
        LD      (CarteRL2+2),A
        DJNZ    DrawCR1
        LD      (CarteRL9+2),A
        LD      HL,CarteRL9
        JR      DrawCarte1

;
; Caractres graphiques pour affichage d'une carte
;
CarteTxt:
        DB      14,1,15,0
CarteL2:
        DB      31,1,2,32,32,32,32,32
CarteL3:
        DB      31,1,3,32,15
CarteL3Pe:
        DB      0
CarteL3Ve:
        DB      32,32
CarteL3Co:
        DB      226,15,0,32
CarteL4:
        DB      31,1,4,32,32,32,32,32
CarteL5:
        DB      31,1,5,32,32,32,32,32
CarteL6:
        DB      31,1,6,32,32,32,32,32
CarteL7:
        DB      31,1,7,32,32,32,32,32
CarteL8:
        DB      31,1,8,32,32,32,32,32,14,0,15,1,#FF

;
; Caractres graphiques pour affichage d'une carte retourne
;
CarteRetournee:
        DB      14,1,15,0
CarteRL1:
        DB      31,1,1,150,154,154,154,154,154,156
CarteRL2:
        DB      31,1,2,149,15,3,207,207,207,207,207,15,0,149,#FF
CarteRL9:
        DB      31,1,1,147,154,154,154,154,154,153
        DB      14,0,15,1,#FF

ValCarte:
        DB      " 7 8 910 V D R A"

MasqueCartes:
        DB      0,0,0,0,0

ScoreCPC:
        DB      0

ScoreJoueur:
        DB      0

;
; Dfinition du jeu de 32 cartes
; bits 4-6 = valeur de la carte
; bits 0-1 = couleur de la carte
;
Jeu32Cartes:
        DB      #00,#10,#20,#30,#40,#50,#60,#70
        DB      #01,#11,#21,#31,#41,#51,#61,#71
        DB      #02,#12,#22,#32,#42,#52,#62,#72
        DB      #03,#13,#23,#33,#43,#53,#63,#73

