;
; Donnes voluant au cours du jeu (donnes  sauvegarder
; ou  lire pour sauver/chager une partie)
;
;
; #######################
; ## Donnes gnrales ##
; #######################
;
IdentData:
        DB      "CPC-AVENTURE.SAV",0    ; Identifiant sauvegarde (cet identifiant
                                        ; permet de reprer une sauvegarde valide
                                        ; sur la disquette d'un secteur vierge.)
NumVue:
        DB      0                       ; Numro de vue en cours
PrevVue:
        DB      0                       ; Numro vue prcdente
ModeUtil:
        DB      0                       ; Mode utilisation
Inventaire:
        DS      10                      ; 10 objets dans l'inventaire
ObjUtil:
        DB      0                       ; Objet utilis


;
; Protections
;
ProtectionArmure:
        DB      0                       ; Protection armure Antiriad obtenue ?
ProtectionEsprit:
        DB      0                       ; Protection contre les esprits obtenue ?
ProtectionMagie:
        DB      0                       ; Protection contre la magie obtenue ?

;
; Variables en fonction des vues
;
AlarmeOff:
        DB      0                       ; Etat de l'alarme de la maison
TrouvePierre:
        DB      0                       ; Trouv pierre devant la maison ?
PorteCassee:
        DB      0                       ; Porte casse ?
TrouveClePlacards:
        DB      0                       ; Trouv cl des placards ?
PerroquetVu:
        DB      0                       ; Perroquet vu ?
PerroquetCalme:
        DB      0                       ; Perroquet calm ?
PerroquetPris:
        DB      0                       ; Perroquet pris ?
WhiskyPris:
        DB      0                       ; Whisky pris ?
PlacardGOuvert:
        DB      0                       ; Placard Gauche ouvert
PlacardMOuvert:
        DB      0                       ; Placard Milieu ouvert
PlacardDOuvert:
        DB      0                       ; Placard Droite ouvert
IngredientsSalon:
        DB      0                       ; Ingrdients du salon pris
TenaillePris:
        DB      0                       ; Tenaille prise ?
MessageTrouve:
        DB      0                       ; Message trouv ?
AilTrouve:
        DB      0                       ; Ail trouv ?
SpatuleTrouvee:
        DB      0                       ; Spatule trouve ?
CasseroleTrouve:
        DB      0                       ; Casserole trouve ?
CasserolePose:
        DB      0                       ; Casserole pose ?
;
; Ingrdients mis dans la casserole. Cette variable s'utilise sous
; sa forme bits,  savoir
; Bit 0 = eau
; Bit 1 = ail
; Bit 2 = poudre
; Bit 3 = fiole
; Bit 4 = touill avec la spatule
;
IngredientsCasserole:
        DB      0
FormuleTrouvee:
        DB      0                       ; Formule trouve ?
PotionOk:
        DB      0                       ; Potion ok ?
CacahoueteTrouve:
        DB      0                       ; Cacahoutes trouvs ?
GrenierOuvert:
        DB      0                       ; Trappe du grenier ouverte ?
EauVidee:
        DB      0                       ; Eau des toilettes vide ?
AmuletteTrouvee:
        DB      0                       ; Amulette trouve ?
PetiteCleTrouvee:
        DB      0                       ; Petite cl trouve ?
BureauOuvert:
        DB      0                       ; Bureau ouvert ?
PotionBue:
        DB      0                       ; Potion bue ?
CpcAllume:
        DB      0                       ; CPC allum ?
GabrielleVue:
        DB      0                       ; Vu ange Gabrielle ?
NbVies:
        DB      1                       ; Nombre de vies dans le jeu
AsterixDejaVu:
        DB      0                       ; Asterix & Obelix dj vu ?
WillyVu:
        DB      0                       ; Vu Willy ?
DizzyVu:
        DB      0                       ; Vu Dizzy ?
EpeePrise:
        DB      0                       ; Epe prise ?
ToucheBarbare:
        DB      0                       ; Nombre de fois touch barbare
ManiementEpee:
        DB      0                       ; Maniement pe acquis.
NbPiecesOr:
        DB      0                       ; Nombre de pices d'or
AccepteSorciere:
        DB      0                       ; Proposition sorcire accepte ?
;
; Ingrdients ncessaire pour la potion de la sorcire.
; Cette variable s'utilise sous sa forme bits,  savoir
; Bit 0 = Fleur tropicale
; Bit 1 = Os humain
; Bit 2 = Energium
IngredientsPotionMagie:
        DB      0
PiecesDonnees:
        DB      0                       ; 10 pices d'or donnes  la sorcire
PiochePrisSalle25:
        DB      0                       ; Pioche prise salle 25 ?
CasquePris:
        DB      0                       ; Casque pris ?
LampePris:
        DB      0                       ; Lampe prise ?
PiochePrisSalle27:
        DB      0                       ; PiochePrise ?
GeantEnFuite:
        DB      0                       ; Gant de la mine en fuite ?
OsPris:
        DB      0                       ; Os pris ? (salle des sacrifices)
CarteGagnee:
        DB      0                       ; Carte au trsor gagn ?
DynamiteDonnee:
        DB      0                       ; Dynamite donne  Rick ?
NavigateurRepare:
        DB      0                       ; Navigateur de Nbulus rpar ?
FleurPrise:
        DB      0                       ; Fleur prise ?
ZakarEnFuite:
        DB      0                       ; Zakar en fuite ?
TaillePhraseArche:
        DB      0                       ; Nombre d'icones saisis (arche)
PhraseArche:
        DS      8                       ; Phase saisie (arche)
PhraseAllie:
        DS      8                       ; Phrase de l'alli (arche)
CoordXArche:
        DW      0                       ; Position arche en X
CoordYArche:
        DW      0                       ; Position arche en Y
CoordAllie1:
        DW      0,0                     ; Position x,y alli 1
CoordAllie2:
        DW      0,0                     ; Position x,y alli 2
CoordAllie3:
        DW      0,0                     ; Position x,y alli 3
AllieTrouve:
        DB      0                       ; Numro de l'alli trouv sur la plante
;
; Etat du dialogue avec l'alli. Cette variable prends plusieurs valeurs :
; - 0 au dpart
; - 1 quand l'alli a pos la seconde question et attends la rponse
; - 
EtatDialAllie:
        DB      0
Allie1Rallie:
        DB      0                       ; Alli 1 ralli ?
Allie2Rallie:
        DB      0                       ; Alli 2 ralli ?
Allie3Rallie:
        DB      0                       ; Alli 3 ralli ?
NbreAllies:
        DB      0                       ; Nombre d'allis rallis
LeconKarate:
        DB      0                       ; Lecon Karat effectue ?
LampeRobinsonPrise:
        DB      0                       ; Lampe de Robinson prise ?
RobinsonVu:
        DB      0                       ; Dj vu Robinson ?
RobinsonAmi:
        DB      0                       ; Robinson est notre ami ?
GrotteVue:
        DB      0                       ; Dj vu la grotte ?
PiratesPartis:
        DB      0                       ; Pirates sur le point de partir ?
CodeBaseOk:
        DB      0                       ; Code de l'entre de la base trouv ?
ArmoireOuverte:
        DB      0                       ; Armoire hotel ouverte ?
;
; Position levier gouts chateau
; Bit 0 = levier 3 (droite)
; Bit 1 = levier 2 (milieu)
; Bit 2 = levier 1 (gauche)
;
PosLevier:
        DB      0
MerlinVu:
        DB      0                       ; Dj vu Merlin ?

PassageSecret:
        DB      0                       ; Passage secret dcouvert ?

CorpsDecouvert:
        DB      0                       ; Corps dcouvert salle ordinateurs ?
MissionAlienOk:
        DB      0                       ; Mission accomplie
BoissonGratuite:
        DB      0                       ; Boisson offerte par Jhonny 5
DejaVuBilly:
        DB      0                       ; Dj vu Billy la banlieue ?
DisquetteGagne:
        DB      0                       ; Disquette gagne ?
