        nolist
BuffSpt     EQU     #300

        ORG     #4000

        JP      Debut

        Read    "IntroSpt.asm"
        Read    "Histoire.asm"

Char126:
        DB      #18,#24,#3C,#66,#7E,#60,#3C,#00 ; 126 = 
        DB      #18,#24,#3C,#66,#66,#66,#3C,#00 ; 127 = 

AfficheHistoire:
        LD      HL,DemandeExpliq
        CALL    PrintTexte
WaitRep:
        CALL    #BB18
        CP      'A'
        JR      C,WaitRep
        AND     #5F
        CP      'N'
        RET     Z
        CP      'O'
        JR      NZ,WaitRep

        LD      A,#10
        CALL    SetAdrMemEcr
        CALL    ClrScr
        DI
        LD      BC,#7F89
        OUT     (C),C
        LD      HL,#3800
        LD      D,H
        LD      E,L
        LD      BC,#800
        LDIR
        LD      BC,#7F8D
        OUT     (C),C
        EI
        LD      HL,Char126
        LD      DE,#3BF0                ; #3800 + 126 * 8
        LD      BC,24
        LDIR
        LD      IX,Histoire1
        CALL    PrintPage
        LD      A,1
        LD      BC,#1A1A                ; Ink 1,26
        CALL    #BC32
        LD      A,#30
        CALL    SetAdrMemEcr
        LD      A,2                     ; Passer en mode 2
        CALL    #BD1C                   ; Sans effacer l'cran (inutile)
        CALL    #BB18
        CALL    ClrScr
        LD      IX,Histoire2
        CALL    PrintPage
        LD      A,#30
        CALL    SetAdrMemEcr
        CALL    #BB18
        LD      A,#30
        JP      SetAdrMemEcr

PrintPage:
        OUT     (C),C
        LD      DE,#C000
PrintPage1:
        LD      BC,#8D0
        LD      A,(IX+0)
        INC     IX
        AND     A
        RET     Z
        LD      L,A
        LD      H,7
        ADD     HL,HL
        ADD     HL,HL
        ADD     HL,HL
        LD      A,D
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        DEC     DE
        ADD     A,B
        LD      D,A
        LDI
        LD      A,D
        ADD     A,C
        LD      D,A
        JR      PrintPage1

SauveScr:
        LD      HL,#C000
        LD      DE,#4000
        LD      BC,#3FD0
        LDIR
        RET

ClrScr:
        LD      BC,#BC06
        OUT     (C),C
        LD      BC,#BD00
        OUT     (C),C
        LD      HL,#C000
        LD      DE,#C001
        LD      BC,#3FCF
        LD      (HL),L
        LDIR
        RET

DrawSpt:
        CALL    DrawWin
        LD      C,25                    ; Pause = 0,5 seconde

WaitVbl:
        CALL    #BD19
        HALT
        HALT
        CALL    #BB09
        RET     C
        DEC     C
        JR      NZ,WaitVBL
        RET

DrawWin:
        LD      DE,XD
        LDI
        LDI
        LDI
        LDI
        PUSH    HL
        CALL    CalcStart
        POP     DE
        LD      HL,(SptScr+1)
        LD      A,(NbLig+1)
        LD      (Draw11+1),A
        LD      A,(NbCol+1)
Draw1:
        PUSH    AF
        PUSH    HL
Draw11:
        LD      A,0
Draw2:
        EX      DE,HL
        LDI
        EX      DE,HL
        LD      BC,#7FF
        ADD     HL,BC
        JR      NC,Draw3
        LD      BC,#C050
        ADD     HL,BC
Draw3:
        DEC     A
        JR      NZ,Draw2
        POP     HL
        INC     HL
        POP     AF
        DEC     A
        JR      NZ,Draw1
        RET
;
; Entre - HL = adresse buffer  dcompacter
;
DepkWin:
        LD      DE,XD
        LDI                             ; Stockage XD
        LDI                             ; Stockage YD
        LDI                             ; Stockage XA
        LDI                             ; Stockage YA
        LD      DE,BuffSpt
        CALL    DepkLzw                 ; Dcompactage
        CALL    CalcStart               ; Calcule adresse dbut et taille
        LD      DE,BuffSpt
;
; DE = adresse buffer
; 
SptScr:
        LD      HL,0
NbLig:
        LD      A,0
NbCol:
        LD      BC,0
        EX      DE,HL
        LDIR
        EX      DE,HL
NbSub:
        LD      BC,#7FF
        ADD     HL,BC
        JR      NC,SptSuite
        LD      BC,#C050
        ADD     HL,BC
SptSuite:
        DEC     A
        JR      NZ,NbCol
        RET

;
; Calcule adresse dbut dans HL
;
CalcStart:
        LD H,#C0
        LD A,(XD)
        LD L,A
        LD A,(YD)
        LD B,A
        AND A
        JR Z,CalcDebBcl
CalcS1:
        LD      DE,#800
        ADD     HL,DE
        JR      NC,CalcS2
        LD      DE,#C050
        ADD     HL,DE
CalcS2:
        DJNZ CalcS1

;
; Calcule nbre de Y
;
CalcDebBcl:
        LD      A,(YD)
        LD      B,A
        LD      A,(YA)
        SUB     B
        INC     A
        LD      B,A              ; B = nbre de y
;
; Calcule nbre de X
;
        LD      A,(XD)

        LD      C,A
        LD      A,(XA)
        SUB     C
        INC     A
        LD      (NbCol+1),A      ; nbre de x
        NEG
        LD      (NbSub+1),A
        LD      A,B
        LD      (NbLig+1),A
        LD      (SptScr+1),HL
        RET

XD:
        DB      0
YD:
        DB      0
XA:
        DB      0
YA:
        DB      0

PrintTexte:
        LD      A,(HL)
        CP      #FF
        RET     Z
        CALL    #BB5A
        INC     HL
        JR      PrintTexte

Pas128k:
        LD      HL,TexteNeed128K
        CALL    PrintTexte
        JR      Pas128k

Debut:
        LD      A,1
        CALL    #BC0E                   ; MODE 1
        CALL    #BB4E                   ; PEN 1 et PAPER 0
        LD      BC,0
        PUSH    BC
        CALL    #BC38                   ; BORDER 0
        POP     BC
        XOR     A
        CALL    #BC32                   ; INK 0,0
        LD      A,1
        LD      BC,#1A1A                ; INK 1,26
        CALL    #BC32
        LD      A,2
        LD      BC,#0F0F                ; INK 2,5
        CALL    #BC32
        LD      A,3
        LD      BC,#0909                ; INK 3,9
        CALL    #BC32

;
; Tester au moins 128Ko
;
        LD      BC,#7FC9
        LD      HL,#4000
Set128k:
        DEC     C
        OUT     (C),C
        LD      (HL),C
        LD      A,C
        CP      #C4
        JR      NZ,Set128k
Test128K:
        OUT     (C),C
        LD      A,(HL)
        CP      C
        JR      NZ,Pas128k
        INC     C
        LD      A,C
        CP      #C9
        JR      NZ,Test128k

        LD      HL,TexteCopyRight
        CALL    PrintTexte

        LD      C,250
        CALL    WaitVbl                 ; Pause= 5 secondes

;
; Sprite Introduction
;
        LD      HL,SptIntro
        CALL    DepkWin

        LD      C,25                    ; Pause = 0,5 seconde
        CALL    WaitVbl

;
; Sprites persos.
;
        LD      HL,Spt1
        CALL    DrawSpt

        LD      HL,Spt2
        CALL    DrawSpt

        LD      HL,Spt3
        CALL    DrawSpt

        LD      HL,Spt4
        CALL    DrawSpt

        LD      HL,Spt5
        CALL    DrawSpt

        LD      HL,Spt6
        CALL    DrawSpt

        LD      HL,Spt7
        CALL    DrawSpt

        LD      HL,Spt8
        CALL    DrawSpt

;
; Sprite Titre
;
        LD      HL,Spt9
        CALL    DrawSpt

        CALL    SauveScr
        CALL    AfficheHistoire
        LD      A,#10
        CALL    SetAdrMemEcr
        LD      A,1
        CALL    #BD1C                   ; Repasser en mode 1
        LD      A,#10
;
; Positionne l'adresse de dbut de la mmoire cran (poids fort)
;
SetAdrMemEcr:
        LD      BC,#BC06
        OUT     (C),C
        LD      BC,#BD19
        OUT     (C),C
        CALL    #BD19
        LD      BC,#BC0C
        OUT     (C),C
        INC     B
        OUT     (C),A
        RET

        Read    "DepkLzw.asm"
        list
_IntroFin:
