        ORG     380

; Constantes lecture intro
LectIntPiste    EQU     0
LectIntSect     EQU     #16C7
StartInt        EQU     #4000

; Constantes lecture sprites
LectSptPiste    EQU     2
LectSptSect     EQU     #16C9
StartSpt        EQU     #4000

; Constantes lecture dialogues
LectDiaPiste    EQU     5
LectDiaSect     EQU     #1AC1
StartDial       EQU     #4000

; Constantes lecture jeu
LectJeuPiste    EQU     7
LectJeuSect     EQU     #18C7
StartJeu        EQU     #02B4

; Constantes lecture dialogues #C7
LectDC7Piste    EQU     10
LectDC7Sect     EQU     #0BC1
StartDC7        EQU     #4000


        JP      Debut

DepkEcr:
        LD      HL,#C000
        Read    "Depklzw.asm"

Debut:
        LD      HL,(#BE7D)
        LD      A,(HL)
        LD      (ReadSect+1),A          ; Sauvegarde drive courant
        CPL
        RST     #18
        DW      FctSetMessage
        CALL    PrintVer
        LD      HL,#1000                ; Adresse lecture intro
        PUSH    HL
        LD      D,LectIntPiste
        LD      BC,LectIntSect
        CALL    ReadSect
        POP     HL
        LD      DE,StartInt
        CALL    DepkLzw
        CALL    StartInt

;
; Lecture sprites
;
        LD      BC,#7FC6
        OUT     (C),C
        LD      HL,StartSpt
        LD      D,LectSptPiste
        LD      BC,LectSptSect
        CALL    ReadSect

;
; Lecture dialogues
;
        LD      BC,#7FC5
        OUT     (C),C
        LD      D,LectDiaPiste
        LD      BC,LectDiaSect
        CALL    ReadSectEcr
        LD      DE,StartDial
        CALL    DepkEcr
;
; Lecture dialogues #C7
;
        LD      BC,#7FC7
        OUT     (C),C
        LD      D,LectDC7Piste
        LD      BC,LectDC7Sect
        CALL    ReadSectEcr
        LD      DE,StartDC7
        CALL    DepkEcr
;
; Lecture jeu
;
        LD      BC,#7FC0
        OUT     (C),C
        LD      D,LectJeuPiste
        LD      BC,LectJeuSect
        CALL    ReadSectEcr
        LD      DE,StartJeu
        PUSH    DE
        JP      DepkEcr

ReadSectEcr:
        LD      HL,#C000
ReadSect:
        LD      E,0
ReadSect2:
        RST     #18
        DW      FctLoadP
        JP      NC,0
        INC     H
        INC     H
        INC     C
        LD      A,C
        CP      #CA
        JR      C,ReadSect3
        LD      C,#C0
        INC     D
ReadSect3:
        DJNZ    ReadSect2
        RET

FctLoadP:
        DW      #C03C
        DB      7

FctSetMessage:
        DW      #C033
        DB      7

Version:
        DB      "CPC-Aventure V1.00 - Chargement...",0

PrintVer:
        LD      HL,Version
PrintVer1:
        LD      A,(HL)
        AND     A
        RET     Z
        INC     HL
        CALL    #BB5A
        JR      PrintVer1
;
; Complter le fichier BASIC avec des zros
;
        DS      1024
