;
; Jouer un sample sur 1,2 ou 4 bit  11Khz
; HL = adresse du sample,
;
PlaySample:
        LD      A,(HL)                  ; Vrifier en-tte "SPL" ok
        INC     HL
        CP      'S'
        RET     NZ
        LD      A,(HL)
        INC     HL
        CP      'P'
        RET     NZ
        LD      A,(HL)
        INC     HL
        CP      'L'
        RET     NZ
        LD      A,(HL)                  ; Vrifier nbre de bits chantillon
        INC     HL
        CP      '4'
        RET     NZ
PlaySampleSet:
        LD      E,(HL)                  ; Rcupre longueur chantillon
        INC     HL
        LD      D,(HL)
        INC     HL
        DI
        LD      A,2
        LD      C,0
        CALL    WriteRegPsg
        LD      A,3
        LD      C,0
        CALL    WriteRegPsg
        LD      A,7
        LD      C,#3D                   ; Activer seulement deuxime canal son
        CALL    WriteRegPsg
PlaySample4Bits:
        LD      A,(HL)
        RRC     A
        RRC     A
        RRC     A
        RRC     A
        AND     #0F
        LD      C,A
        LD      A,9
        CALL    WriteRegPsg
        LD      B,5
PlaySample4Bits2:
        DJNZ    PlaySample4Bits2
        LD      A,(HL)
        AND     #0F
        LD      C,A
        RRC     A
        RRC     A
        RRC     A
        RRC     A
        LD      A,9
        CALL    WriteRegPsg
        LD      B,5
PlaySample4Bits3:
        DJNZ    PlaySample4Bits3
        INC     HL
        DEC     DE
        LD      A,D
        OR      E
        JR      NZ,PlaySample4Bits
        LD      C,D
        LD      A,9
        CALL    WriteRegPsg
        EI
        RET

;
; Ecriture d'un registre du PSG
; A = numro de registre
; C = valeur
;
WriteRegPsg:
        LD      B,#F4
        OUT     (C),A
        LD      B,#F6
        IN      A,(C)
        OR      #C0
        OUT     (C),A
        AND     #3F
        OUT     (C),A
        LD      B,#F4
        OUT     (C),C
        LD      B,#F6
        LD      C,A
        OR      #80
        OUT     (C),A
        OUT     (C),C
        RET
